#include "demo.i"

		.global	playroutine
		.global	loadinstr

playroutine:
		sbic	GPIOR0, GFLAG_SONGEND
		rjmp	play_sound

		ldi	r27, hi8(ch)

		lds	r16, tracktimer
		subi	r16, 1
		brcs	1f
		rjmp	play_nonewline
1:
		lds	r16, trackpos
		subi	r16, 1
		brcs	2f
		rjmp	play_nonewpos
2:
		; new song position

		ldi	r26, lo8(ch)		; loop through channels with X as channel pointer
play_songch:
		lds	r28, songptr
		lds	r29, songptr+1
		lds	r25, songbits

		rcall	ophuffman
		ldi	r17, 0
		cpi	r16, 96
		brlo	2f
		subi	r16, 96 + 16
		brne	1f
		sbi	GPIOR0, GFLAG_SONGEND
		rjmp	play_sound
1:
		mov	r17, r16
		rcall	ophuffman
2:
		; r16 is track number, r17 is transpose

		sts	songptr, r28
		sts	songptr+1, r29
		sts	songbits, r25

		ldi	r30, lo8(tracks)
		ldi	r31, hi8(tracks)
		lsl	r16
		add	r30, r16
		adc	r31, r3

		movw	r28, r26
		lpm	r18, Z+
		lpm	r19, Z

		std	Y+c_tptr, r18
		std	Y+c_tptr+1, r19
		std	Y+c_tbits, r3
		std	Y+c_transp, r17

		adiw	r26, c_sz
		cpi	r26, lo8(ch+3*c_sz)
		brne	play_songch

		ldi	r16, 24-1		; tracklen
play_nonewpos:
		sts	trackpos, r16

		; new track line

		ldi	r26, lo8(ch)		; loop through channels with X as channel pointer
play_linech:
		movw	r30, r26
		ldd	r28, Z+c_tptr
		ldd	r29, Z+c_tptr+1
		ldd	r25, Z+c_tbits

		rcall	ophuffman
		ldi	r17, 0
		lsr	r16
		brcs	3f
		lsr	r16
		brcs	2f

		; end of track

		ldi	r28, lo8(endtrack)
		ldi	r29, hi8(endtrack)
		ldi	r25, 0
		ldi	r16, 0
		rjmp	3f
2:
		mov	r17, r16
		rcall	ophuffman
		lsr	r16
3:
		; r16 is note, r17 is instr

		movw	r30, r26
		std	Z+c_tptr, r28
		std	Z+c_tptr+1, r29
		std	Z+c_tbits, r25

		movw	r28, r26

		tst	r17
		breq	play_noinstr

		rcall	loadinstr
		tst	r16
		breq	play_nonote

		std	Y+c_lasti, r17
play_noinstr:
		tst	r16
		breq	play_nonote

		ldd	r17, Y+c_transp
		add	r16, r17
		subi	r16, 1

		ldd	r17, Y+c_lasti
		rcall	loadinstr

		std	Y+c_note+1, r16
		std	Y+c_note, r3
		std	Y+c_glide, r3
		std	Y+c_fade, r3
		std	Y+c_pwd, r3
		std	Y+c_vdepth, r3
		ldi	r16, 48
		std	Y+c_ivol, r16
		ldi	r16, 15
		std	Y+c_vrate, r16

play_nonote:
		adiw	r26, c_sz
		cpi	r26, lo8(ch+3*c_sz)
		brne	play_linech

		ldi	r16, 4-1		; tempo
play_nonewline:
		sts	tracktimer, r16

play_sound:
		ldi	r28, lo8(ch)		; loop through channels with Y as channel pointer
		ldi	r29, hi8(ch)
		ldi	r24, 0			; total noise volume

play_ch:
		ldd	r16, Y+c_itime		; waiting?
		subi	r16, 1
		brcc	play_idone

		ldd	r16, Y+c_iptr
		ldi	r30, lo8(instruments)
		ldi	r31, hi8(instruments)
		add	r30, r16
		adc	r31, r3

		lpm	r17, Z
		inc	r16
		std	Y+c_iptr, r16

		movw	r30, r28

		mov	r16, r17
		andi	r17, 0x0f
		andi	r16, 0xf0

		; r16 is command, r17 is param

		brmi	1f
		brne	4f

		rcall	loadinstr
		rjmp	play_ch
4:
		cpi	r16, 0x10
		brne	5f

		swap	r17
		rjmp	6f
5:
		cpi	r16, 0x20
		brne	6f

		lsl	r17
		lsl	r17
6:
		swap	r16
		add	r30, r16
		st	Z, r17
		rjmp	play_ch
1:
		swap	r16
		lsr	r16
		brcc	2f
		neg	r17
2:
		add	r30, r16
		ldd	r16, Z+c_note+1-4
		add	r16, r17
		std	Z+c_note+1-4, r16
		rjmp	play_ch

play_idone:
		std	Y+c_itime, r16

		ldd	r18, Y+c_note		; here's our note value in 8.8 format
		ldd	r19, Y+c_note+1

		ldd	r30, Y+c_vpos
		ldi	r31, hi8(sine)
		lpm	r17, Z			; r17 is sin(vibrpos)
		ldd	r16, Y+c_vdepth
		mulsu	r17, r16		; r1:r0 is wanted vibrato offset times 2

		asr	r1
		ror	r0
		add	r18, r0			; update note
		adc	r19, r1

		ldd	r16, Y+c_vrate
		add	r30, r16
		add	r30, r16
		std	Y+c_vpos, r30

		ldi	r16, 6			; number of octaves to shift
6:
		dec	r16
		subi	r19, 12
		brcc	6b

		subi	r19, 256-12

		ldi	r30, lo8(freq)
		ldi	r31, hi8(freq)
		lsl	r19
		add	r30, r19
		adc	r31, r3

		lpm	r20, Z+			; r21:r20 is freq
		lpm	r21, Z+
		lpm	r22, Z+
		lpm	r23, Z+
		sub	r22, r20
		sbc	r23, r21		; r23:r22 is dist
8:
		subi	r16, 1
		brcs	9f
		lsr	r21
		ror	r20
		lsr	r23
		ror	r22
		rjmp	8b
9:
		; Now we want to compute freq += (dist * lo(note)) >> 8.
		; The offset to add to freq will be stored in r19:r18.

		mul	r23, r18		; r1:r0 is product of hi(dist) and lo(note)
		movw	r16, r0
		mul	r22, r18		; r1:r0 is product of lo(dist) and lo(note)
		add	r16, r1
		adc	r17, r3

		add	r20, r16
		adc	r21, r17

		ldd	r18, Y+c_note		; here's our note value in 8.8 format
		ldd	r19, Y+c_note+1
		ldd	r16, Y+c_glide
		ldi	r17, 16
		muls	r16, r17
		add	r18, r0
		adc	r19, r1

		brpl	1f
		mov	r18, r3
		mov	r19, r3
1:
		std	Y+c_note, r18
		std	Y+c_note+1, r19

		ldd	r16, Y+c_ivol
		ldd	r17, Y+c_fade
		add	r16, r17
		sbrc	r16, 7
		ldi	r16, 0
		sbrc	r16, 6
		ldi	r16, 63
		std	Y+c_ivol, r16

		ldd	r17, Y+c_pw
		ldd	r18, Y+c_pwd
		add	r17, r18
		cpi	r17, 0xf4
		brlo	2f
		subi	r17, 256-0x18
2:
		ldd	r18, Y+c_noise
		add	r24, r18

		subi	r18, 1
		brcs	3f
		std	Y+c_noise, r18
3:
		std	Y+c_pw, r17
		std	Y+c_freq+1, r21
		std	Y+c_freq, r20
		std	Y+c_vol, r16

		adiw	r28, c_sz
		cpi	r28, lo8(ch+3*c_sz)
		breq	5f
		rjmp	play_ch
5:
		sts	noisevol, r24

		ret

loadinstr:
		; Inputs:
		;	r17	Instrument number
		;	Y	Channel data
		; Clobbers:
		;	Z

		ldi	r30, lo8(instruments + 1)
		ldi	r31, hi8(instruments + 1)
		add	r30, r17
		adc	r31, r3
		lpm	r30, Z
		std	Y+c_iptr, r30
		std	Y+c_itime, r3
		ret

