#include "demo.i"

		.global	unpackpic
		.global	ophuffman
		.global	getcolour
		.global	huffman

huff_ee:
		subi	r29, 0x80
		out	EEARH, r29
		out	EEARL, r28
		sbi	EECR, 0
		subi	r29, 0x80
		adiw	r28, 1
		in	r25, EEDR
		rjmp	huff_gotbyte
huff_branch:
		lsl	r25
		brne	huff_gotbit

		sbrc	r29, 7
		rjmp	huff_ee

		movw	r0, r30
		movw	r30, r28
		lpm	r25, Z+
		movw	r28, r30
		movw	r30, r0
huff_gotbyte:
		sec
		rol	r25
huff_gotbit:
		brcc	1f
		add	r30, r16
		adc	r31, r3
1:
		; drop through...

huffman:
		; Input:
		;	r25	Bit buffer
		;	Y	Bit stream pointer (flash or eeprom)
		;	Z	Start of huffman table
		; Output:
		;	r16	Retrieved value
		; Clobbers:
		;	r0, r1

		lpm	r16, Z+
		lsr	r16
		brcs	huff_branch
		ret

ophuffman:
		ldi	r30, lo8(ophuff)
		ldi	r31, hi8(ophuff)
		rjmp	huffman

unpackpic:
		; Input:
		;	Y	Pointer to bit stream in flash or eeprom
		;	r25	Bit buffer for stream reader
		; Local state:
		;	r16	Value from huffman table
		;	r18	Current x coordinate
		;	r20	Current bg/even
		;	r21	Current bg/odd
		;	r22	Current fg/even
		;	r23	Current fg/odd
		;	r24	Last tile
		;	r25	Bit buffer for stream reader
		;	X	Output pointer (tile byte for current position)
		;	Z	Huffman table
		; Also clobbers:
		;	r0, r1, r17

		ldi	r26, 0x08
		ldi	r27, 0x02

		ldi	r18, 0
upp_loop:
		rcall	ophuffman

		lsr	r16
		brcs	upp_tile
		lsr	r16
		brcs	upp_rept

upp_ctrl:
		mov	r17, r16

		sbrs	r17, 0
		rjmp	1f

		movw	r0, r20
		movw	r20, r22
		movw	r22, r0
1:
		sbrs	r17, 1
		rjmp	2f

		rcall	getcolour
		mov	r20, r16
		rcall	getcolour
		mov	r21, r16
2:
		sbrs	r17, 2
		rjmp	upp_loop

		rcall	getcolour
		mov	r22, r16
		rcall	getcolour
		mov	r23, r16

		rjmp	upp_loop

upp_tile:
		mov	r24, r16
		ldi	r16, 1
upp_rept:
		st	X+, r24
		movw	r0, r26
		add	r26, r18
		adc	r27, r3
		adiw	r26, 18			; x = &row->even[x].bg
		st	X+, r20
		mov	r17, r20		; x = &row->even[x].fgbg
		eor	r17, r22
		st	X, r17
		adiw	r26, 37			; x = &row->odd[x].bg
		st	X+, r21
		mov	r17, r21		; x = &row->odd[x].fgbg
		eor	r17, r23
		st	X, r17
		movw	r26, r0

		inc	r18
		cpi	r18, 19
		brne	1f

		adiw	r26, 19 * 2
		adiw	r26, 19 * 2
		cpi	r27, 5
		breq	do_ret
		ldi	r18, 0
1:
		subi	r16, 1
		brne	upp_rept
		rjmp	upp_loop

getcolour:
		ldi	r30, lo8(palhuff)
		ldi	r31, hi8(palhuff)
		rcall	huffman
		subi	r16, 256-0x33
do_ret:		ret

